;Auntie Johns's Space Invaders Source Code
;Copyright (c) May 1989 John Kennedy
;Donated to WACCI Software Library.
;This program is NOT in the Public Domain

nolist
set_mode equ &bc0e
test_key equ &bb1e
txt_output equ &bb5a
set_cursor equ &bb75
wait_frame equ &bd19
rom_off equ &b903
set_ink equ &bc32
get_ink equ &bc35
set_border equ &bc38
amp_env equ &bcbc
ton_env equ &bcbf
sound equ &bcaa
quiet equ &bca7
soundhold equ &bcb6
soundcont equ &bcb9
time_please equ &bd0d
wait_key equ &bb18
win_enable equ &bb66

start
	call rom_off
	call set_sound
	call Title_screen
	call set_major_variables
mainloop
	call set_variables
	call set_screen
	call set_skill
	call set_invaders
	call wait
loop
	call Invaders
	call Base
	call Saucer
	call Pause_game
	ld a,(flag)
	cp 0:jr z,loop
	cp 1:jr z,Quit_game
	cp 2:jr z,Game_over
	cp 3:jr z,Lost_a_life
	cp 4:jr z,New_Sheet
Quit_game
	ld a,2:jp Set_mode
New_sheet
	ld hl,string4:call print_string
	ld a,(sheet):inc a:ld (sheet),a
	call wait
	jr mainloop
Game_over
	ld hl,string3:call print_string
	call wait:call wait:call wait:
	call Check_entry:jp start
Lost_a_life
	call sound2
	call flash_inks
	ld ix,space:call print_missile
	xor a:ld (bomb),a:ld (missile),a:ld (flag),a
	ld a,(lives):dec a:ld (lives),a
	call Print_lives
	call wait
	ld a,(lives)
	cp 0						
	jr nz,loop					
	jr Game_over
Wait	ld b,100					
wloop	call Wait_Frame
	djnz wloop
	ret
Title_screen						
	call fade_inks
	ld a,1:call Set_mode				
	ld hl,string6:call print_string
	call Display_table
	call set_inks
not_pressed
	ld a,47:call Test_key				
	jr z, not_pressed				
	ret
Set_Screen						
	call fade_inks
	ld a,1:call set_mode				
	ld hl,string1:call Print_string
	ld hl,string2:call Print_string
	call Print_Sheet
	call Print_score
	call Print_lives
	call Print_high
	call set_inks
	ret

pause_game
	ld a,16
	call test_key
	ret z
	push ix
	call soundhold
lb2	ld a,79
	call test_key
	jp z,lb2
	call soundcont
	pop ix
	ret

set_inks
	xor a:ld bc,0:call set_ink
	ld a,1:ld bc,&1818:call set_ink	
	ld a,2:ld bc,&1414:call set_ink
	ld a,3:ld bc,&606:call set_ink
	ld bc,0:jp set_border

short_delay
	call wait_frame:call wait_frame:call wait_frame
	call wait_frame:call wait_frame:jp wait_frame

flash_inks
	ld b,27
flop	push bc
	dec b:ld c,b:call set_border
	pop bc:push bc
	dec b:ld a,0:ld c,b:call set_ink
	call short_delay
	pop bc
	djnz flop
	ret
fade_inks
	ld b,27
flop2	push bc
	ld a,1:call dec_ink
	ld a,2:call dec_ink
	ld a,3:call dec_ink
	call short_delay
	pop bc
	djnz flop2
	ret
dec_ink	push af
	call get_ink
	ld a,b
	cp 0
	jr z,no_change
	dec b:dec c
no_change
	pop af
	call set_ink
	ret



set_sound
	ld a,1
	ld hl,env1
	call amp_env
	ld a,2
	ld hl,env2
	call amp_env
	ld a,3
	ld hl,env3
	call amp_env
	ld a,1
	ld hl,ent1
	call ton_env
	ld a,2
	ld hl,ent2
	call ton_env
	ld a,3
	ld hl,ent3
	call ton_env
	ret

Saucer
	call Set_saucer
	call Move_saucer
	ret


Base	call Print_Base					
	call Move_Base					
	call Control_missile
	ret
Invaders						
	push iy:pop ix:call Print_Invaders		
	call Move_invaders				
	call Control_bomb				
	ret

Set_saucer
	ld a,(saucerpos)
	cp 0
	ret nz
	call time_please
	ld a,l
	cp 100
	ret nz
	ld a,1
	ld (saucerpos),a
	ret
Move_saucer
	ld a,(saucerpos)
	cp 0
	ret z
	ld a,(saucercount)
	xor 255
	ld (saucercount),a
	cp 0
	ret nz
	call sound6
	ld ix,space:call Print_saucer
	ld a,(saucerpos):inc a:ld (saucerpos),a
	cp 70
	jr z,stop_saucer
	ld ix,saucergr:call Print_saucer
	ret
stop_saucer
	ld a,0
	ld (saucerpos),a
	ret
print_saucer
	ld a,(saucerpos):ld l,a:ld h,1
	push hl						
	call print:push de:pop ix			
	pop hl:push hl					
	inc l:inc l
	call print:push de:pop ix
	pop hl
	ld a,4:add l:ld l,a
	call print
	ret

Print_Base						
	ld a,(basepos)
	ld l,a
	ld h,24
	push hl:ld ix,basegr:call print:pop hl
	inc l:inc l
	push hl:ld ix,basegr+16:call print:pop hl
	inc l:inc l
	ld ix,basegr+32:call print
	ret
Move_Base						
	ld a,66:call Test_key				
	call nz,esc					
        ld a,(left):call Test_key
	call nz,baseleft
	ld a,(right):call Test_key
	call nz,baseright
	ld a,(fire):call Test_key
	call nz,basefire
	ret
esc	ld a,1:ld (flag),a				
	ret						
baseleft
	ld a,(basepos)
	cp 0
	ret z						
	dec a						
	ld (basepos),a
	ret
baseright
	ld a,(basepos)
	cp 70						
	ret z
	inc a
	ld (basepos),a
	ret
basefire
	ld a,(missile)					
	cp 0						
	ret nz
	call sound0						
	ld a,(basepos):inc a:inc a:ld (missile),a	
	ld a,23:ld (missile+1),a			
	ret
Control_Missile						
	ld a,(missile):cp 0:ret z
	ld ix,space:call print_missile
	ld a,(missile+1):dec a:ld (missile+1),a
	call look_under_missile
	cp 255
	jr z,hit_the_shield
	ld a,(missile+1)
	cp 0:jr z,stopmissile
	ld ix,missilegr:call print_missile
	ret
stopmissile
	ld a,(saucerpos)
	cp 0
	call nz,hit_saucer?
	xor a:ld (missile),a				
	ret
hit_the_shield
	ld hl,(missile):ld ix,space:call print
	xor a:ld (missile),a
	ret
hit_saucer?
	ld b,a
	ld a,(missile)
	sub b
	cp 6
	ret nc
	call sound5
	ld bc,50:call increase_score
	ld ix,space:call print_saucer
	ld a,0:ld (saucerpos),a
	ret
Look_under_missile
	ld hl,(missile):jp look
Print_missile
	ld a,(missile)
	cp 0:ret z
	ld hl,(missile):jp print
Print_Invaders
	xor a:ld (moveflag),a
	ld b,4						
	ld de,invadersdata				
	ld a,(ypos)					
	ld h,a
lpb	push bc
	ld b,7						
	ld a,(xpos)					
	ld l,a						
lpc	push bc
	ld a,(de):cp 0:jr z,delay	
	push de:push hl
	call Print_Alien					
	pop hl:pop de:push de:push hl
	call Check_Invader                              
	pop hl:pop de
	ld (de),a
 dead	inc de
	ld a,6:add l:ld l,a
	pop bc
	djnz lpc
	ld a,3:add h:ld h,a
	pop bc
	djnz lpb					
	ret						
delay	ld b,90
lp3	djnz lp3					
	jp dead						
							
Print_Alien						
	push ix						
	push hl						
	call print:push de:pop ix			
	pop hl:push hl					
	inc l:inc l
	call print:push de:pop ix
	pop hl:push hl
	ld a,4:add l:ld l,a
	call print:push de:pop ix
	pop hl:push hl:inc h
	call print:push de:pop ix
	pop hl:push hl:inc h
	inc l:inc l
	call print:push de:pop ix
	pop hl:push hl:inc h
	ld a,4:add l:ld l,a
	call print
	pop hl
	pop ix 
	ret
Check_Invader
	ld a,(missile)
	cp 0
	jp z,not_hit			
	sub l
	cp 6
	jp nc,not_hit					
	ld a,(missile+1)
	sub h
	cp 2
	jp nc,not_hit					
	
	push hl:ld ix,space:call print_missile:pop hl	
	ld ix,banggr:call Print_Alien
	push hl:call sound1:pop hl
	call wait_frame:call wait_frame:call wait_frame		
	push hl
	xor a:ld (missile),a					
	ld a,(hits):inc a:ld (hits),a			
	cp 28:jr nz,not_all_dead			
	ld a,4:ld (flag),a
not_all_dead
	ld bc,5:call increase_score
	pop hl
	ld ix,space:call Print_Alien:ld ix,aliengr2	
	xor a
	ret
not_hit	call Drop_Bomb
	ld a,l:cp 0:call z,movedown			
	ld a,l:cp 70:call z,movedown			
	ld a,h:cp 22:jr nz,not_landed			
	ld a,2:ld (flag),a
not_landed
	ld a,1
	ret
movedown
	ld a,1:ld (moveflag),a:ret


Drop_bomb
	ld a,(bomb):cp 0:ret nz
	push hl:push de
	ld hl,7
	add hl,de
	ld a,(hl)
	cp 0
	jr nz,no_bomb
	ld de,7
	add hl,de
	ld a,(hl)
	cp 0
	jr nz,no_bomb
	call time_please
	ld a,l
	and 31
	cp 30
	jr nz,no_bomb
	pop de:pop hl
	ld a,h:inc a:inc a:ld (bomb+1),a
	ld a,l:inc a:inc a:ld (bomb),a
	ret
no_bomb pop de:pop hl:ret
Control_Bomb
	ld a,(bomb):cp 0:ret z
	ld hl,(bomb)
	ld ix,space:call print
	ld a,(bomb+1):inc a:ld (bomb+1),a
	cp 25:jr z,stopbomb
	cp 24:jr z,past_shield
	ld hl,(bomb):call look
	ld a,(hl):cp 0:jr nz,hit_shield
past_shield	
	ld hl,(bomb)	
	ld ix,bombgr:call print	
	ret
stopbomb
	ld a,(basepos):ld b,a
	ld a,(bomb)
	sub b
	cp 6
	jr nc,reset_bomb
	ld a,3:ld (flag),a
reset_bomb
	xor a:ld (bomb),a
	ret
hit_shield
	ld hl,(bomb):ld ix,space:call print
	xor a:ld (bomb),a
	ret
Move_invaders
	ld a,(count):inc a:ld (count),a
	ld b,a:ld a,(speed)
	cp b
	ret nz
	xor a:ld (count),a
	call Swap_graphics
	ld a,(moveflag)
	cp 0
	jr nz,come_on_down
	ld a,(dir)
	ld hl,xpos
	add (hl)
	ld (hl),a
	ret
come_on_down
	ld a,(dir)
	xor 254 
	ld (dir),a
	ld hl,xpos
	add (hl)
	ld (hl),a
	ld ix,space:call Print_invaders
	ld a,(ypos):inc a:ld (ypos),a
	ret
Increase_score
	ld hl,(score):add hl,bc:ld (score),hl	
	call Print_score
	ret
                     
Print_score
	ld hl,1793:call set_cursor:ld hl,(score):jp printhl
Print_high
	ld hl,8705:call set_cursor:ld hl,(high):jp printhl
Print_sheet
	ld hl,5889:call set_cursor:ld a,(sheet):ld l,a:ld h,0:jp printhl
Print_lives				
	ld hl,string5:call print_string
	ld a,(lives)
	cp 0:ret z
	ld b,a
llop	ld a,239:call txt_output
	djnz llop
	ret
Swap_graphics
	ld a,(animate)
	xor 255
	ld (animate),a
	ld iy,aliengr1
	cp 0
	jr z,sound3
	ld iy,aliengr2
	jr sound4

sound0
	ld hl,snd0
	jp putsound
sound1
	ld hl,snd1
	jp putsound
sound2
	ld hl,snd2
	jp putsound
sound3
	ld a,(saucerpos)
	cp 0
	ret nz
	ld hl,snd3
	jp putsound
sound4
	ld a,(saucerpos)
	cp 0
	ret nz
	ld hl,snd4
	jp putsound
sound5
	ld hl,snd5
	jp putsound
sound6
	ld hl,snd6
	jp putsound
putsound
	push ix
	call sound
	pop ix
	ret


Set_Invaders
	ld b,28	
	ld hl,invadersdata
lpa	ld (hl),1
	inc hl
	djnz lpa
	ld a,2
	ld (xpos),a
	ld a,1
	ld (dir),a
	xor a
	ld (count),a
	ld (saucerpos),a
	ld (saucercount),a
	ret
Set_variables
	ld iy,aliengr2	
	xor a:ld (animate),a
	ld a,20
	ld (basepos),a
	xor a
	ld (flag),a
	ld (hits),a
	ld hl,0
	ld (bomb),hl
	ld (missile),hl
	ret
Set_Major_Variables
	ld hl,0
	ld (score),hl
	ld a,3
	ld (lives),a
	ld a,1
	ld (sheet),a
	ld a,10
	ld (speed),a
	ret
Set_Skill
	ld a,(sheet):inc a
	ld (ypos),a
	cp 9
	ret nz
	ld a,8:ld (ypos),a
	ld a,(speed)
	dec a
	ld (speed),a
	cp 2
	ret z
	ld a,3:ld (speed),a
	ret

flag 		db 0	
speed	 	db 0	
count	 	db 0	
invadersdata 	ds 28	
db 0,0,0,0,0,0,0
db 0,0,0,0,0,0,0
moveflag 	db 0	
dir 		db 0	
xpos 		db 0	
ypos 		db 0	
left 		db 8
right 		db 1
fire 		db 23
missile 	dw 0
bomb 		dw 0
basepos 	db 0
saucerpos	db 0
saucercount	db 0
hits 		db 0	
animate		db 0
lives 		db 0
sheet 		db 0
space 		ds 96,0	

string1
db 15,1,31,1,1,"SCORE:          SHEET:      HIGH:     $"
string2
db 15,3,14,0,31,6,20,214,143,215,"      ",214,143,215
db "      ",214,143,215,"      ",214,143,215
db 31,6,21,143,143,143,"      ",143,143,143
db "      ",143,143,143,"      ",143,143,143
db 31,6,22,212,32,213,"      ",212,32,213
db "      ",212,032,213,"      ",212,032,213,15,1,"$"
string3
db 31,14,10,"GAME OVER$"
string4
db 31,14,10,"WELL DONE$"
string5
db 31,13,1,32,32,32,31,13,1,"$"
string6
db 15,1,31,14,1,"Space Invaders"
db 15,2,31,19,2, "by"
db 15,1,31,15,3,"Auntie John"
db 15,2,31,11,24,"Press Space to Play$"
string7
db 15,1,31,1,4,"Good score! Please enter your name:"
db 31,13,10,">--------------------<",31,14,10,15,2,"$"

look
ld e,l:ld a,h:sla a:ld hl,chartable:ld b,0:ld c,a:add hl,bc
ld a,(hl):ld c,a:inc hl:ld a,(hl):ld b,a
ld l,e:ld h,0:add hl,bc:ld a,(hl):ret

.print
push ix:ld e,l:ld a,h:sla a:ld hl,chartable:ld b,0:ld c,a:add hl,bc
ld a,(hl):ld c,a:inc hl:ld a,(hl):ld b,a
ld l,e:ld h,0:add hl,bc:pop de:ld bc,&7ff
ld a,(de):ld (hl),a:inc hl:inc de:ld a,(de):ld (hl),a:inc de:add hl,bc
ld a,(de):ld (hl),a:inc hl:inc de:ld a,(de):ld (hl),a:inc de:add hl,bc
ld a,(de):ld (hl),a:inc hl:inc de:ld a,(de):ld (hl),a:inc de:add hl,bc
ld a,(de):ld (hl),a:inc hl:inc de:ld a,(de):ld (hl),a:inc de:add hl,bc
ld a,(de):ld (hl),a:inc hl:inc de:ld a,(de):ld (hl),a:inc de:add hl,bc
ld a,(de):ld (hl),a:inc hl:inc de:ld a,(de):ld (hl),a:inc de:add hl,bc
ld a,(de):ld (hl),a:inc hl:inc de:ld a,(de):ld (hl),a:inc de:add hl,bc
ld a,(de):ld (hl),a:inc hl:inc de:ld a,(de):ld (hl),a:inc de:ret
chartable
dw &C000,&C050,&C0A0,&C0F0,&C140,&C190,&C1E0,&C230,&C280
dw &C2D0,&C320,&C370,&C3C0,&C410,&C460,&C4B0,&C500,&C550
dw &C5A0,&C5F0,&C640,&C690,&C6E0,&C730,&C780

print_string
ld a,(hl)
cp "$"
ret z
call txt_output
inc hl
jr print_string

printhl
ld de,10000:call pr1:ld de,1000:call pr1:ld de,100:call pr1
ld de,10:call pr1:ld de,1:pr1:ld a,255:pr2:inc a:scf:ccf:sbc hl,de
jp nc,pr2:add hl,de:add 48:jp &bb5a

bombgr
db 0,12,3,192,48,12,0,195,0,60,3,192,48,12,0,192
missilegr
db 1,8,1,8,1,8,0,0,16,128,16,128,0,0,17,136
aliengr1
db 0,0,0,0,0,51,0,116,0,248,0,248,0,248,0,234
db 119,238,248,241,240,240,148,146,150,150,240,240,240,240,240,240
DB 0,0,0,0,204,0,226,0,241,0,241,0,241,0,49,0
db 0,234,0,234,0,251,0,249,0,252,0,50,0,0,0,0
db 98,100,64,32,32,64,136,0,196,17,136,0,0,0,0,0
db 117,0,117,0,117,0,249,0,226,0,200,0,0,0,0,0
aliengr2 
db 0,0,0,51,0,116,0,248,0,248,0,248,0,234,0,234
db 248,241,240,240,146,148,150,150,240,240,240,240,240,240,234,117
db 0,0,204,0,226,0,241,0,241,0,241,0,117,0,117,0
db 0,234,0,234,0,234,0,224,0,224,0,228,0,238,0,0
db 100,98,34,68,0,0,0,0,0,0,0,0,0,0,0,0
db 117,0,117,0,117,0,112,0,112,0,114,0,119,0,0,0
basegr
db 0,0,0,0,0,0,0,0,0,7,0,120,0,120,0,120
db 1,8,16,128,19,132,54,194,120,225,240,240,240,240,240,240
db 0,0,0,0,0,0,0,0,14,0,225,0,225,0,225,0
saucergr
db 0,0,0,1,0,18,0,52,0,52,0,18,0,1,0,0
db 15,15,240,240,245,253,253,253,253,253,240,240,240,15,15,250,15
db 8,240,132,253,194,253,233,253,233,240,194,120,132,143,8
banggr 	 
db 0,0,0,16,0,84,0,102,0,51,0,145,0,240,0,128
db 0,136,17,40,145,104,209,128,241,59,141,78,251,12,75,93
db 0,0,0,0,64,0,255,0,136,0,0,0,17,0,238,0
db 0,248,0,51,0,69,0,113,0,17,0,204,0,68,0,136
db 135,120,47,140,240,107,20,33,84,118,220,68,4,34,48,102
db 224,0,0,0,136,0,238,0,51,0,128,0,128,0,0,0
env1 db 1,15,-1,1
env2 db 1,15,-1,20
env3 db 1,10,-1,5
ent1 db 1,10,15,1
ent2 db 1,10,-5,1
ent3 db 130,&f0,50,2,&f0,80,2
snd0 db 129,1,1,32,2,0,15,0,0		;laser fire
snd1 db 129,1,0,100,0,15,15,0,0		;laser hit alien
snd2 db 135,2,0,0,0,31,15,0,0		;base hit
snd3 db 130,3,0,32,4,0,10,0,0		;alien move
snd4 db 130,3,0,32,3,0,10,0,0		;alien move
snd5 db 135,1,0,0,0,15,15,0,0		;saucer hit
snd6 db 130,3,3,0,0,0,10,0,0		;saucer

DISPLAY_TABLE
	ld h,6:ld d,34
	ld l,5:ld e,20
	call WIN_ENABLE
	ld hl,TABLE
	ld b,10
next_entry
	push bc
	call PRINT_A_STRING
	push hl
	ld a,(hl):ld e,a
	inc hl
	ld a,(hl):ld d,a
	ex de,hl
	call PRINT_A_SPACE
	call printhl
	call NEW_LINE
	pop hl
	inc hl:inc hl
	pop bc
	djnz NEXT_ENTRY
	ret

NEW_LINE
	ld a,10
	call Txt_output
	ld a,13
	call Txt_output
	ret

Print_a_string
	ld b,20
psl	ld a,(hl)
	call txt_output
	inc hl
	djnz psl
	ret

Print_a_space
	ld a,32
	call Txt_output
	ret
TABLE
	db "Captain Midnight    "
high	dw  5000
	db "Green               "
	dw 4500
	db "Colin T             "
	dw 4000
	db "SuperPhil           "
	dw 3000
	db "Old Jiffy Gnolegs   "
	dw 2000
	db "Steve and Joolz     "
	dw 1000
	db "The WACCI crowd     "
	dw 500
	db "Wish you were here  "
	dw 200
	db "Sledge Hammer  -    "
	dw 100
LAST_NAME
	db "Coming soon!        "
LOWEST_SCORE
	dw 50
INPUT_BUFFER
	ds 20
score dw 0
CHECK_ENTRY
	ld bc,(SCORE)
	ld hl,(LOWEST_SCORE)
	scf:ccf
	sbc hl,bc
	ret nc
	call GET_NAME
	call INSERT_NAME
	ret

GET_NAME
	call fade_inks
	ld a,1:call set_mode
	call NEW_LINE
	call NEW_LINE
	ld hl,string7:call print_string
	call set_inks
	call GET_A_STRING
	ret

GET_A_STRING
	call &bb03
	ld hl,INPUT_BUFFER
	ld b,20
BLANK	ld a,32
	ld (hl),a
	inc hl
	djnz BLANK
	ld hl,INPUT_BUFFER
	ld b,0
INLOOP	call WAIT_KEY
	cp 13
	ret z
	cp 127
	jr z,DELETE
	cp 126
	jr nc,INLOOP
	cp 31
	jr c,INLOOP
	call TXT_OUTPUT
	ld (hl),a
	inc hl
	inc b
	ld a,b
	cp 20
	jr nz,INLOOP
	ret
DELETE
	ld a,b
	cp 0
	jr z,INLOOP
	dec b
	dec hl
	ld a,32
	ld (hl),a
	ld a,8:call TXT_OUTPUT
	ld a,32:call TXT_OUTPUT
	ld a,8:call TXT_OUTPUT
	jr INLOOP


INSERT_NAME
	ld hl,LAST_NAME
INSERT	push hl
	ld bc,20
	add hl,bc
	ld a,(hl):ld e,a
	inc hl
	ld a,(hl):ld d,a
       	ld bc,21
	add hl,bc
	ld a,(hl):ld c,a
	inc hl
	ld a,(hl):ld b,a
	ex hl,de
	scf:ccf
	sbc hl,bc
	jr nc,EXIT
	pop hl
	push hl
	call SWAP
	pop hl
	ld bc,22
	scf:ccf
	sbc hl,bc
	ld de,table-22
	ld a,h:cp d
	jr nz,INSERT
	ld a,l:cp e
	jr nz,INSERT
	ret
EXIT	pop hl
	ret

SWAP
	push hl
	ld de,SWAP_SPACE
	ld bc,22
	ldir
	pop hl:push hl
	ld de,22
	add hl,de
	pop de:push hl
	ld bc,22
	ldir
	pop de
	ld hl,SWAP_SPACE
	ld bc,22
	ldir
	ret
SWAP_SPACE
	ds 22

